// stek1.h - Definicija klase Stek.

#include <iostream.h>

class Stek {
  int *niz, kap, vrh;               // Sadrzaj, kapacitet i vrh steka.

  void kopiraj (const Stek &s);                   // Kopiraj stek.

  void brisi () { delete [] niz; kap = vrh = 0; } // Brisi stek.

public:

  Stek (int k=10) {                      // Pravi stek datog kapaciteta.
    niz = new int [kap = k]; vrh = 0;
  }

  Stek (const Stek &s) { kopiraj (s); }  // Pravi stek kao kopija drugog.

  ~Stek () { brisi (); }                 // Unisti stek.

  Stek & operator= (const Stek &s) {     // Dodela vrednosti.
    if (&s != this) { brisi (); kopiraj (s); }
    return *this;
  }

  void stavi (int k);                          // Stavi podatak na stek.

  int uzmi ();                                 // Uzmi podatak sa steka.

  void prazni () { vrh = 0; }                  // Isprazni stek.

  int prazan () const { return vrh == 0;   }   // Da li je prazan?

  int pun    () const { return vrh == kap; }   // Da li je pun?

  friend ostream & operator<< (ostream &d, const Stek &s);   // Ispisivanje.

};
