// Stek1.java - Definicije metoda uz klasu Stek1.

class Stek1 {

  private int[] niz;                  // Sardzaj steka.
  private int vrh;                    // Vrh steka.

  public Stek1 () {                   // Pravi stek velicine 10.
    niz = new int [10]; vrh = 0;
  }

  public Stek1 (int k) {              // Pravi stek zadatog kapaciteta.
    niz = new int [ k]; vrh = 0;
  }

  public Stek1 (Stek1 s) {            // Pravi stek od kopije drugog.
    niz = new int [s.niz.length];
    vrh = s.vrh;
    for (int i=0; i<vrh; i++) niz[i] = s.niz[i];
  }

  public void stavi (int k) {         // Stavi podatak na stek.
    if (vrh == niz.length) {
      System.out.print ("\n*** Sek je pun ***\n");
      System.exit (1);
    }
    niz[vrh++] = k;
  }

  public int uzmi () {                // Uzmi podatak sa steka.
    if (vrh == 0) {
      System.out.print ("\n*** Sek je prazan ***\n");
      System.exit (2);
    }
    return niz[--vrh];
  }

  public void prazni () { vrh = 0; }  // Isprazni stek.

  public boolean prazan () { return vrh == 0; }          // Da li je prazan?

  public boolean pun    () { return vrh == niz.length; } // Da li je pun?

  public String toString () {         // Pretvori sadrzaj steka u
    String s = "";                    //   u znakovni niz.
    for (int i=vrh; i>0; s+=niz[--i]+" ");
    return s;
  }

  // Glavni program za ispitivanje klase Stek1. ==========================
  public static void main (String[] argi) {
    Stek1 s = new Stek1 ();
    while (! s.pun    ()) { s.stavi (Citaj.Int()); }
    while (! s.prazan ()) { System.out.print (s.uzmi() + " "); }
    System.out.println ();
  }

};
