// Krug.java - Klasa krugova u ravni.

package Ravan;

public class Krug {
  
  private static class Elem {
    Krug krug; Elem sled;
    Elem (Krug k) { krug = k; sled = null; }
    Elem (Krug k, Elem s) { krug = k; sled = s; }
  }

  Tacka c; double r;        // Pojedinani podaci.

  static Elem prvi = null;  // Zajednika lista svih krugova.

  public static boolean moze (double r, double x, double y) {
    Krug k = new Krug (); k.r = r; k.c = new Tacka (x, y);
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      if (tek.krug.rastojanje (k) < 0) return false;
    return true;
  }
  
  private Krug () { c = new Tacka (); r = -1; } // Samo za interne potrebe.
  
  public Krug (double r, double x, double y) {
    if (! moze (r, x, y)) System.exit (1);
    this.r = r;
    this.c = new Tacka (x, y);
    prvi = new Elem (this, prvi);
  }

  public void  brisi () {
    Elem tek=prvi, preth=null;
    while (tek.krug != this) { preth=tek; tek=tek.sled; };
    if (preth == null) prvi       = tek.sled;
      else             preth.sled = tek.sled;
  }

  public boolean postavi (double x, double y) {
    if (! moze (r, x, y)) return false;
    c.x = x; c.y = y; return true;
  }

  public boolean pomeri (double dx, double dy) {
    if (! moze (r, c.x+dx, c.y+dy)) return false;
    c.x += dx; c.y += dy; return true;
  }

  double rastojanje (Krug k) { return c.rastojanje (k.c) - r - k.r; }

  public String toString () 
    { return "K[" + r + ",(" + c.x + "," + c.y + ")]"; }

}
