// djak.h - Definicija klase djaka (Djak).

// Djak je osoba koja ide u neki razred neke skole.

#ifndef __djak__h__
#define __djak__h__

#include "osoba.h"

class Djak : public Osoba {

  ZnNiz skola; int razred;

public:

  Djak () { razred = 0; }

  Djak (const ZnNiz &im, long ro, const ZnNiz &sk, int ra)
    : Osoba (im,ro), skola(sk) { razred = ra; }

  virtual ~Djak () {}

  virtual Djak * kopija () const { return new Djak (*this); }

  void  postavi_skolu  (const ZnNiz &sk) { skola  = sk; }

  void  postavi_razred (      int    ra) { razred = ra; }

  ZnNiz dohvati_skolu  () const { return skola;  }

  int   dohvati_razred () const { return razred; }

protected:

  void citaj (istream &dat) {
    Osoba::citaj (dat);
    cout << "Skola?   "; dat >> skola;
    cout << "Razred?  "; dat >> razred;
  }

  void pisi (ostream &dat) const {
    Osoba::pisi (dat);
    dat << endl << skola << " (" << razred << ')';
  }

};

#endif

