// osoba.h - Definicija klase osoba (Osoba).

// Osoba ima ime i datum rodjenja.

#ifndef __osoba__h__
#define __osoba__h__

#include "znniz.h"
#include <iostream.h>

class Osoba {

  ZnNiz ime; long rodjen;

public:

  Osoba () { rodjen = 0; }

  Osoba (const ZnNiz &im, long ro) : ime(im) { rodjen = ro; }

  virtual ~Osoba () {}

  virtual Osoba * kopija () const { return new Osoba (*this); }

  void  postavi_ime    (const ZnNiz &im) { ime    = im; }

  void  postavi_rodjen (      int    ro) { rodjen = ro; }

  ZnNiz dohvati_ime    () const { return ime;    }

  long  dohvati_rodjen () const { return rodjen; }

protected:

  virtual void citaj (istream &dat) {
    cout << "Ime?     "; dat >> ime;
    cout << "Rodjen?  "; dat >> rodjen;
  }

  virtual void pisi (ostream &dat) const
    { dat << ime << " (" << rodjen << ')'; }

  friend istream & operator>> (istream &da, Osoba &os)
    { os.citaj (da); return da; }


  friend ostream & operator<< (ostream &da, const Osoba &os)
    { os.pisi (da); return da; }

};

#endif

