// sef.h - Definicija klase za sefove (Sef).

// Sef je zaposleni koji prima sefovski dodatak.

#ifndef __sef__h__
#define __sef__h__

#include "zaposl.h"

class Sef : public Zaposleni {

  double dodatak;

public:

  Sef () { dodatak = 0; }

  Sef (const ZnNiz &im, long ro,
       const ZnNiz &fi, double sa, double rs, double sd)
    : Zaposleni(im,ro,fi,sa,rs) { dodatak = sd; }

  virtual ~Sef () {}

  virtual Sef * kopija () const { return new Sef (*this); }

  void postavi_dodatak (double sd) { dodatak = sd; }

  double dohvati_dodatak () const { return dodatak; }

  double plata () const { return Zaposleni::plata () + dodatak; }

  void citaj (istream &dat) {
    Zaposleni::citaj (dat);
    cout << "Dodatak? "; dat >> dodatak;
  }

  void pisi (ostream &dat) const {
    Osoba::pisi (dat);
     dat << endl << firma << " (" << satnica << '*' << r_sati
         << '+' << dodatak << '=' << plata () << ')';
  }

};

#endif
