// zaposl.h - Definicija klase zaposlenih (Zaposleni).

// Zaposleni je osoba koja radi u nekoj firmi i
// prima platu na osnovu satnice i broja radnih sati.

#ifndef __zaposl__h__
#define __zaposl__h__

#include "osoba.h"

class Zaposleni : public Osoba {

protected:
  ZnNiz firma; double satnica, r_sati;

public:

  Zaposleni () { satnica = r_sati = 0; }

  Zaposleni (const ZnNiz &im, long ro,
             const ZnNiz &fi, double sa, double rs)
    : Osoba(im,ro), firma(fi) { satnica = sa; r_sati = rs; }

  virtual ~Zaposleni () {}

  virtual Zaposleni * kopija () const { return new Zaposleni (*this); }

  void   postavi_firmu      (const ZnNiz &fi) { firma   = fi;   }

  void   postavi_satnicu    (      double sa) { satnica = sa; }

  void   postavi_radne_sate (      double rs) { r_sati  = rs;  }

  ZnNiz  dohvati_firmu      () const { return firma;   }

  double dohvati_satnicu    () const { return satnica; }

  double dohvati_radne_sate () const { return r_sati;  }

  virtual double plata  () const { return satnica * r_sati; }

protected:

  void citaj (istream &dat) {
    Osoba::citaj (dat);
    cout << "Firma?   "; dat >> firma;
    cout << "Satnica? "; dat >> satnica;
    cout << "Br.sati? "; dat >> r_sati;
  }

  void pisi (ostream &dat) const {
    Osoba::pisi (dat);
    dat << endl << firma << " ("
        << satnica << '*' << r_sati << '=' << plata() << ')';
  }

};

#endif
