// znniz.h - Definicija klase za znakovne nizove ZnNiz.

#ifndef __znniz__h__
#define __znniz__h__

#include <string.h>
#include <iostream.h>

class ZnNiz {

  char *niz;

  void kopiraj (const char *ni)
    { strcpy ((niz = new char [strlen(ni)+1]), ni); }

public:

  ZnNiz () { niz = 0; }

  ZnNiz (const char *ni) { kopiraj (ni); }

  ZnNiz (const ZnNiz &zn) { kopiraj (zn.niz); }

  ~ZnNiz () { delete [] niz; }

  ZnNiz & operator= (const ZnNiz &zn) {
    if (this != &zn) { delete [] niz; kopiraj (zn.niz); }
    return *this;
  }

  friend istream & operator>> (istream &dat, ZnNiz &zn)
    { char pom[81]; dat >> pom; zn = pom; return dat; }

  friend ostream & operator<< (ostream &dat, const ZnNiz &zn)
    { return dat << zn.niz; }
} ;

#endif

