// Red.java - Red za cekanje u obliku liste.

class Red implements Obj {

  private Elem prvi, posl;

  public Red () {}

  public Red (Obj obj) { prvi = posl = new Elem (obj); }

  public Obj kopija () {
    Red red = new Red ();
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      Elem novi = new Elem (tek.obj.kopija ());
      if (red.posl == null) red.prvi      = novi; 
        else                red.posl.sled = novi;
      red.posl = novi;
    }
    return red;
  }

  public void stavi (Obj obj) {
    Elem novi = new Elem (obj);
    if (posl == null) prvi = novi; else posl.sled = novi;
    posl = novi;
  }

  public Obj uzmi () throws EPrazan {
    if (prvi == null) throw new EPrazan ();
    Obj obj = prvi.obj;
    prvi = prvi.sled;
    if (prvi == null) posl = null;
    return obj;
  }

  public void isprazni () { prvi = posl = null; }

  public Obj citaj () { isprazni (); return this; }

  public String toString () {
    String s = "[";
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      s += tek.obj;
      if (tek != posl) s = s + " ";
    }
    return s +"]";
  }

}
