// Kupac.java - Kupac samoposluge.

class Kupac extends Thread {

  private Samoposluga samoposluga;
  private int maxKupovina, idBroj;
  private static int ukBroj = 0;

  Kupac (Samoposluga samoposluga, int maxKupovina) {
    this.samoposluga = samoposluga;
    this.maxKupovina = maxKupovina;
    idBroj = ++ukBroj;
    start ();
  }

  public void run () {
    try { sleep ((long) (Math.random () * maxKupovina)); } 
      catch (InterruptedException e) {}
    Kasa[] kase = samoposluga.dohvatiKase ();
    Kasa kasa = kase[(int)(Math.random()*kase.length)];
    kasa.staviURed (this);
    System.out.println ("Kupac #" + idBroj + 
      " je stao u red ispred kase #" + kasa.dohvatiIdBroj() + 
      " samoposluge #" + samoposluga.dohvatiIdBroj());
    synchronized (this) {
      try { wait (); } catch (InterruptedException e) {}
    }
    samoposluga.izasaoKupac ();
    System.out.println ("Kupac #" + idBroj +
      " je izasao iz samoposluge #" + samoposluga.dohvatiIdBroj());    
  }
  
  void naplaceno () { synchronized (this) { notify (); } }

  int dohvatiIdBroj () { return idBroj; }

}
