// Kasa.java - Kasa samoposluge.

class Kasa extends Thread {

  private Samoposluga samoposluga;
  private Red red;
  private int maxNaplata, idBroj;
  private boolean gotovo=false, radi=true;
  private static int ukBroj = 0;

  Kasa (Samoposluga samoposluga, int maxNaplata) {
    this.samoposluga = samoposluga;
    this.maxNaplata  = maxNaplata;
    red = new Red ();
    idBroj = ++ukBroj;
    start();
  }

  public void run () {
    System.out.println ("Kasa #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " je spremna za rad");
    boolean prvi = true;
    while (true) {
      if (! radi) {
        if (! prvi)
          System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je zatvorena.");
        prvi = false;
        synchronized (this) 
          { try { wait (); } catch (InterruptedException e) {} }
        if (! gotovo)
          System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je otvorena.");
      }
    if (gotovo) break;
      Kupac kupac = red.uzmi ();
    if (kupac == null) break;
      System.out.println ("Kupac #" + kupac.dohvatiIdBroj() + 
        " je stigao na kasu #" + idBroj + " samoposluge #" +
        samoposluga.dohvatiIdBroj());
      try { sleep ((long) (Math.random() * maxNaplata)); } 
        catch (InterruptedException e) {}
      kupac.naplaceno ();
    }
    System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " vise ne postoji.");
  }

  synchronized void zatvori () {
    radi = false;
    System.out.println ("Kasa #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " se zatvara.");
  }

  synchronized void otvori () {
    radi = true; notify ();
    System.out.println ("Kasa #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " se otvara.");
  }

  synchronized void zavrsi () {  
    gotovo = true; notify ();
    red.zavrsi ();
  }

  void staviURed (Kupac kupac) { red.stavi (kupac); }
  
  int dohvatiIdBroj () { return idBroj; }

}
