// Ulaz.java - Ulaz u samoposlugu.

class Ulaz extends Thread {

  private Samoposluga samoposluga;
  private int maxUlaz, maxKupovina, idBroj;
  private boolean gotovo=false, radi=false;
  private static int ukBroj = 0;

  Ulaz (Samoposluga samoposluga, int maxUlaz, int maxKupovina) {
    this.samoposluga = samoposluga;
    this.maxUlaz = maxUlaz;
    this.maxKupovina = maxKupovina;
    idBroj = ++ukBroj;
    start ();
  }

  public void run () {
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " je spreman za rad");
    boolean prvi = true;
    while (true) {
      if (! radi) {
        if (! prvi)
          System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je zatvoren.");
        prvi = false;
        synchronized (this) 
          { try { wait (); } catch (InterruptedException e) {} }
        if (! gotovo)
          System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je otvoren.");
      }
    if (gotovo) break;
      try { sleep ((long) (Math.random() * maxUlaz)); } 
        catch (InterruptedException e) {}
      samoposluga.usaoKupac ();
      Kupac kupac = new Kupac (samoposluga, maxKupovina);
      System.out.println ("Kupac #" + kupac.dohvatiIdBroj() +
        " je usao kroz ulaz #" + idBroj + " samoposluge #" + 
        samoposluga.dohvatiIdBroj());
    }
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " vise ne postoji.");
  }

  synchronized void zatvori () {
    radi = false;
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " se zatvara.");
  }

  synchronized void otvori () {
    radi = true;
    notify ();
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " se otvara.");
  }

  synchronized void zavrsi () {  
    gotovo = true; 
    notify ();
  }

  int dohvatiIdBroj () { return idBroj; }

}
